local MSG = require "api_msg"
local CO = require "api_coservice"
local cjson = require "cjson"

local dset = {}



local function API_GetLink(red, args)
	local proxy = CO.GetProxy( "/cameraLink", "mediaserver" )
	if not proxy then
		MSG.ERROR( "Failure to connect mediaserver service" )
		return true
    else


		local r, data,err = proxy.GetLink()
        proxy:Destroy()
		if r and data then
            local src = data["cameraLink"] or ""
            local protocol = data["protocol"]
            local port = data["http_port"]
            if data["protocol"] ~= "http://" and data["protocol"] ~= "https://" then
                protocol = "http://"
            elseif data["protocol"] == "https://" then
                port = data["https_port"]
            end
			MSG.OK("",{data = {src=src,protocol = protocol,port = port}})
		else
			MSG.ERROR( "Failed to query serial device information" )
		end
		return true
	end
end 

local function API_SetLink(red, args)
	local proxy = CO.GetProxy( "/cameraLink", "mediaserver" )
	if not proxy then
		MSG.ERROR( "Failure to connect mediaserver service" )
		return true
    else
        if args.src and args.protocol then
            local r, data,err = proxy.SetLink(args.src,args.protocol)
            proxy:Destroy()
            if r and data then
                MSG.OK("")
            else
                MSG.ERROR( "Failed to query serial device information" )
            end
            return true
        else
            proxy:Destroy()
            MSG.ERROR( "not find src" )
            return true
        end
	end
end 
--------------
--
dset.APIS = dset.APIS or {}
--
dset.APIS["get"] = API_GetLink
dset.APIS["modify"] = API_SetLink

--
return dset
--
