local coaf = require "coaf.core"
local lfs = require "lfs"
require "features"

local _M = {
	cpu = { load = 0, idle = 99 },
}
function _M.GetUSBSerials()
	local usb_drv
	local attrs

	local devices = {}
	--BUG fix: 
	if not lfs.attributes( "/sys/bus/usb-serial/drivers" ) then
		return devices
	end

	for usb_drv in lfs.dir("/sys/bus/usb-serial/drivers") do
		if usb_drv ~= "." and usb_drv ~= ".." and not usb_drv:match("option") then
			--attrs = lfs.attributes( "/sys/bus/usb-serial/drivers/" .. usb_drv )
			local item
			local drv_type = "GENERIC"
			if usb_drv:match("ftdi") then
				drv_type = "FTDI"
			elseif usb_drv:match("pl23") then
				drv_type = "PL230X"
			end

			for item in lfs.dir( "/sys/bus/usb-serial/drivers/" .. usb_drv ) do
				if item ~= "." and item ~= ".." and item:match("tty.+") then
					table.insert( devices, { device=item, driver=drv_type })
				end
			end
		end
	end

	return devices
end

return _M