local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/cameraLink.conf"
}

--------------------------------------------

local streamer_template = DC.OBJ({
    protocol = DC.STR(""),
	cameraLink = DC.STR(""),
	http_port = DC.INT(1080),
	https_port = DC.INT(10443),
	http_open = DC.BOOL(true),
	https_open = DC.BOOL(true)
}) : __changed( function(conf)
	conf:TAB_SAVE()
end)

--------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, streamer_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	conf:TAB_LOAD()
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M


