local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/streamer.conf"
}

--------------------------------------------

local streamer_template = DC.SET(
	DC.OBJ{
		name = DC.STR(""),
		source_stream = DC.STR(""),
		sourceType = DC.STR("main"),
		streams = DC.SET(
			DC.OBJ{
				name = DC.STR(""),
				type = DC.STR("rtmp_push"),
				enable = DC.BOOL(false),

				address = DC.STR(""),
				auth = DC.BOOL(false),
				user = DC.STR(""),
				password = DC.STR(""),

				service_port = DC.INT(0),
				alter_port = DC.INT(0),

				video_port = DC.INT(0),
				audio_port = DC.INT(0),
				multicast = DC.BOOL(false),
				multicast_address = DC.STR(""),
				multicast_ttl = DC.INT(127)
			}
		)
	}
) : __changed( function(conf)
	conf:TAB_SAVE()
end)

local failDefault = {
	["1"] = {
		name = "public",
		source_stream = "",
		sourceType = "",
		streams = {
			[1] = {
				stream_id = 1,
				address = "local",
				enable = false,
				name = "NDI|HX",
				type = "ndi-hx",
				channel_name = "Channel-HX",
				device_group = "",
				ndi_connection = "tcp",
				netprefix = "239.255.0.0",
				netmask = "255.255.0.0",
				ttl = "127",
				id = 1
			}
		}

	}
}

--------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, streamer_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _,r = conf:TAB_LOAD()
	if not r then
		conf:TAB_BIND(failDefault)
		conf:TAB_SAVE()
	end
	conf:TAB_LOAD()
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M


