local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/streams.conf"
}

--------------------------------------------
--[[
local streams_template = DC.SET(
	DC.OBJ{
		name = DC.STR(""),
		audio_enables = DC.SET( DC.BOOL(false) ), --Enable audio groups
		manual = DC.BOOL(false),
		manual_type = DC.STR("manual"),
		manual_url = DC.STR(""),
		with_sub = DC.BOOL(false),
		sub_url = DC.STR(""),
		buffer_option = DC.STR("live:200:200:500:0:0"),
		options = DC.OBJ{
			username = DC.STR(""),
			password = DC.STR(""),
			transport = DC.STR("tcp"),
			connect_speed  = DC.INT(2), --0-极低，1-较低 2-正常 3-较高
			bind = DC.STR("*"),
			rtp_video_port = DC.INT(0),
			rtp_audio_port = DC.INT(0),
			rtp_video_codec = DC.STR("96,H264/90000"),
			rtp_audio_codec = DC.STR("97,MPEG4-GENERIC/48000/2"),
			origin = DC.STR(""),
			imgUrl = DC.STR("")
		}
	}
) : __changed( function(conf)
	conf:TAB_SAVE()
end)
--]]

local streams_template = DC.SET(
	DC.OBJ{
		name = DC.STR(""),
		audio_enables = DC.SET( DC.BOOL(false) ), --Enable audio groups
		manual = DC.BOOL(false),
		manual_type = DC.STR("manual"),
		with_sub = DC.BOOL(false),
		stream_type = DC.STR("main"),
		options = DC.OBJ{
			type = DC.STR("unknown"),
			url = DC.STR(""),
			username = DC.STR(""),
			password = DC.STR(""),
			transport = DC.STR("tcp"),
			connect_speed  = DC.INT(2), --0-极低，1-较低 2-正常 3-较高
			bind = DC.STR("*"),
			rtp_video_port = DC.INT(0),
			rtp_audio_port = DC.INT(0),
			rtp_video_codec = DC.STR("96,H264/90000"),
			rtp_audio_codec = DC.STR("97,MPEG4-GENERIC/48000/2"),
			buffer_option = DC.STR("live:200:200:500:0:0")
		},

		sub_options = DC.OBJ{
			type = DC.STR("unknown"),
			url = DC.STR(""),
			username = DC.STR(""),
			password = DC.STR(""),
			transport = DC.STR("tcp"),
			connect_speed  = DC.INT(2), --0-极低，1-较低 2-正常 3-较高
			bind = DC.STR("*"),
			rtp_video_port = DC.INT(0),
			rtp_audio_port = DC.INT(0),
			rtp_video_codec = DC.STR("96,H264/90000"),
			rtp_audio_codec = DC.STR("97,MPEG4-GENERIC/48000/2"),
			buffer_option = DC.STR("live:200:200:500:0:0")
		}
	}
) : __changed( function(conf)
	conf:TAB_SAVE()
end)
--------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, streams_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	conf:TAB_LOAD()
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M


