local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/tun.conf"
}

--------------------------------------------

local tun_template = DC.OBJ({     
        tunip = DC.STR(""),
        tunport = DC.INT(0),
        tunuser = DC.STR(""),
        tunpass = DC.STR(""),
        tunrealm = DC.STR(""),
        serverip = DC.STR(""),
        serverport = DC.INT(60000),
}) : __changed( function(conf)
	conf:TAB_SAVE()
end)

local failDefault = {
        tunip= "192.168.0.1",
        tunport = 3478,
        tunuser = "admin",
        tunpass = "123456",
        tunrealm = "demo",
        serverip = "192.168.0.1",
        serverport = 60000
}
--------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, tun_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
        local _, r = conf:TAB_LOAD()
        if not r then --Try load a fail-default configure 
	        conf:TAB_BIND(failDefault)
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M
